﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace praktika_nasledovanie
{
    interface birds
    {
        //метод, принимающий в себя значение массы птицы
        void massa(int znachenie);

        //метод, рассчитывающий, сколько грамм корма необходимо птице в зависимости от ее веса
        int raschet_korma();

        void otryad(string vvedennii_otryad);
    }
    class predatory_birds: birds
    {
        //поле, хранящее в себе значение массы птицы
        public int bird_mass;
        string[] otryadi = { "ястребиные", "скопиные", "соколиные", "секретари", "грифы" };

        //переопределенный метод, присваивающий введенное пользователем значение массы птицы соответствующему полю
        public void massa(int znachenie) 
        {
            bird_mass = znachenie;
        }

        //переопределенный метод, который в соответствии с некоторым условием возвращает необходимую граммовку корма 
        public int raschet_korma()
        {
            if (bird_mass >= 100 && bird_mass < 200) return (bird_mass / 100 * 20);
            else if (bird_mass >= 200 && bird_mass < 800) return (bird_mass / 100 * 15);
            else if (bird_mass >= 800 && bird_mass < 7000) return (bird_mass / 100 * 10);
            else return (int)(bird_mass / 100 * 3.5);
        }

        //переопределенный метод, определяющий, являются ли введенные отряды птиц хищными
        public void otryad(string vvedennii_otryad)
        {
            if (Array.IndexOf(otryadi, vvedennii_otryad) >= 0) vvedennii_otryad = "Птицы в данном отряде являются хищными";
            else vvedennii_otryad = "Возможно, у введенного отряда птиц другой рацион питания";
            Console.WriteLine(vvedennii_otryad);
        }
    }

    class penguin: predatory_birds
    {
        string is_penguin;

        //замещенный метод, который в более понятной форме представляет информацию о том, сколько корма нужно птице
        new public string raschet_korma()
        {
            if (bird_mass >= 100 && bird_mass < 200) return "Ему необходимо " + (bird_mass / 100 * 20).ToString() + "г корма в день";
            else if (bird_mass >= 200 && bird_mass < 800) return "Ему необходимо " + (bird_mass / 100 * 15).ToString() + "г корма в день";
            else if (bird_mass >= 800 && bird_mass < 7000) return "Ему необходимо " + (bird_mass / 100 * 10).ToString() + "г корма в день";
            else return "Ему необходимо " + (bird_mass / 100 * 3.5).ToString() + "г корма в день";
        }

        //уникальный метод, выводящий в консоль звуки, издаваемые введенным пользователем существом
        public void speak(string znach)
        {
            is_penguin = znach;
            if (is_penguin == "пингвин") Console.WriteLine("Ее звуки: " + "хррр" + "-aу-ау-ау-" + "треск-треск");
            else Console.WriteLine("Неизвестная птица, издаваемые ей звуки не зафиксированы");
        }
    }
}
